@echo off
REM communicates with amplayrcg
Title AMPlayRCC
set rcver=2.00
set rcdate=29.10.2005
echo.
set in=p:\ramdisc\in.txt
set inflag=p:\ramdisc\inflag.txt
set out=p:\ramdisc\out.txt
set outflag=p:\ramdisc\outflag.txt
set wakeflag=p:\ramdisc\wakeflag.txt
set dispfile=c:\temp\amdisp.txt
set tmpfile=c:\temp\amtmp.txt
set webfile=c:\temp\current.txt
set verbose=off
set find=%systemroot%\system32\find.exe
set sleep=%systemroot%\sleep.exe
set timedask=c:\utils\timedask.exe
set temp=%systemroot%\temp
if not exist %temp% md %temp%
if exist %in% del %in%
if exist %inflag% del %inflag%
if exist %out% del %out%
if exist %outflag% del %outflag%
if exist %dispfile% del %dispfile%
set autoupdate=0
title AMPlay Remote Control Client %rcver% %rcdate%

echo.
echo AMPlay Remote Control Client %rcver% %rcdate%.
echo.
echo Sending initial request . . .
goto request

:top
cls
echo.
if exist %dispfile% type %dispfile%

echo.
echo Keys:   pAuse, Next, Force, Restart, Previous, Quieter, Louder,
echo         reWind, fOrward, Sleep, waKe, Update, Halt, More, eXit
:loop
set act=
%timedask% /n "wait" anfrpqlwoskuhmx 5 >nul
if errorlevel 1 set act=cmd#pau#tog
if errorlevel 2 set act=cmd#nxt#nrm
if errorlevel 3 set act=cmd#nxt#mod
if errorlevel 4 set act=cmd#rst#nrm
if errorlevel 5 set act=cmd#pre#nrm
if errorlevel 6 set act=cmd#vdn#bas#nrm
if errorlevel 7 set act=cmd#vup#bas#nrm
if errorlevel 8 set act=cmd#rew#nrm
if errorlevel 9 set act=cmd#fwd#nrm
if errorlevel 10 set act=rcg#sleep
if errorlevel 15 goto exit
if errorlevel 14 goto extra
if errorlevel 13 goto halt
if errorlevel 12 goto request
if errorlevel 11 goto wake
if not %act%.==. goto action
if %autoupdate%.==0. goto request
if %autoupdate%.==1. goto request
if %autoupdate%.==2. echo.
if %autoupdate%.==2. echo Autoupdate disabled.
set autoupdate=3
goto loop

:wake
rem wake up remote system
echo.
echo Waking up AMPlayRCG . . .
echo.>%wakeflag%
%sleep% 1
goto request

:halt
rem turn off autoupdate.
echo.
echo Autoupdate disabled.
set autoupdate=3
goto loop

:extra
cls
echo.
if exist %dispfile% type %dispfile%
echo.
echo Keys:   Hist:   Artist, aLbum, Prevartist, pRevalbum
echo         List:   arTist, alBum, prEvartist, preValbum
echo         Others: Quitamplay, laUnchamplay, Savestate, More
:xloop
set act=
%timedask% /n "wait" alprtbevqusm 5 >nul
if errorlevel 1 set act=cmd#nar#nrm
if errorlevel 2 set act=cmd#nal#nrm
if errorlevel 3 set act=cmd#par#nrm
if errorlevel 4 set act=cmd#pal#nrm
if errorlevel 5 set act=cmd#nar#mod
if errorlevel 6 set act=cmd#nal#mod
if errorlevel 7 set act=cmd#par#mod
if errorlevel 8 set act=cmd#pal#mod
if errorlevel 9 set act=cmd#die#nrm
if errorlevel 10 set act=rcg#run
if errorlevel 11 set act=cmd#sta
if errorlevel 12 goto top
if not %act%.==. goto action
if %autoupdate%.==0. goto top
if %autoupdate%.==1. goto top
if %autoupdate%.==2. echo Autoupdate disabled.
set autoupdate=3
goto xloop



:request
if %autoupdate%.==3. set autoupdate=2
set wait=0
REM send request for updated information
if exist %inflag% if not exist %in% goto recover
if exist %inflag% goto fetch
if exist %outflag% if exist %out% del %out%
if exist %outflag% del %outflag%
echo req#mac#atc#0#AMPlay: %%vs>%in%
echo req#mac#atc#0# Track: %%tb - %%lxtn (%%zdu) : %%zel>>%in%
echo req#mac#atc#0# Album: %%lbn (%%zbd)>>%in%
echo req#mac#atc#0#Artist: %%lan (%%zad)>>%in%
echo req#mac#atc#0#Status: %%ss>>%in%
echo req#mac#atc#0#Volume: %%zpv>>%in%
echo req#mac#atc#0#set percent=%%zpc>>%in%
echo.>%inflag%
if %verbose%.==on. echo Update request sent (%autoupdate%).
if exist %outflag% goto fetch
if %verbose%.==on. set wait=0.1
%sleep% 0
if exist %outflag% goto fetch
if %verbose%.==on. set wait=0.2
%sleep% 0
if exist %outflag% goto fetch
if %verbose%.==on. set wait=0.3
%sleep% 0
if exist %outflag% goto fetch
if %verbose%.==on. set wait=0.4
%sleep% 0
if exist %outflag% goto fetch
if %verbose%.==on. set wait=1
%sleep% 1
if exist %outflag% goto fetch
if %verbose%.==on. set wait=2
%sleep% 1
if exist %outflag% goto fetch
if %verbose%.==on. set wait=3
%sleep% 1
goto fetch

:fetch
if not exist %outflag% goto noresp
if not exist %out% goto noresp
if %verbose%.==on. echo Update response received (%autoupdate%) (wait=%wait%).
if exist %tmpfile% del %tmpfile%
if %verbose%.==on. echo Parsing response.
copy %out% %tmpfile% >nul
type %tmpfile% | %find% "rcg#sleep: Succeeded." /i >nul
if errorlevel 1 goto f2
goto rcgasleep

:f2
type %tmpfile% | %find% "Error:66:AMPlay is not running." /i >nul
if errorlevel 1 goto f3
goto notrunning

:f3
type %tmpfile% | %find% "AMPlay: " /i >%dispfile%
echo.>>%dispfile%
type %tmpfile% | %find% " Track: " /i >>%dispfile%
type %tmpfile% | %find% " Album: " /i >>%dispfile%
type %tmpfile% | %find% "Artist: " /i >>%dispfile%
echo.>>%dispfile%
type %tmpfile% | %find% "Status: " /i >>%dispfile%
type %tmpfile% | %find% "Volume: " /i >>%dispfile%
type %dispfile%>%webfile%
echo.>>%webfile%
echo Generated by AMPlayRCC.bat v%rcver% %rcdate% >>%webfile%

echo @echo off>%temp%\rctmp.bat
type %out% | %find% "set percent=" >>%temp%\rctmp.bat
if errorlevel 1 goto nopc
call %temp%\rctmp.bat
del %temp%\rctmp.bat


echo.>>%dispfile%
echo         Ŀ>>%dispfile%

  if %percent%.==0. echo                                                              0%%>>%dispfile%
  if %percent%.==1. echo                                                             1%%>>%dispfile%
  if %percent%.==2. echo                                                             2%%>>%dispfile%
  if %percent%.==3. echo         ۱                                                   3%%>>%dispfile%
  if %percent%.==4. echo                                                            4%%>>%dispfile%
  if %percent%.==5. echo         ۱                                                  5%%>>%dispfile%
  if %percent%.==6. echo                                                           6%%>>%dispfile%
  if %percent%.==7. echo         ۱                                                 7%%>>%dispfile%
  if %percent%.==8. echo                                                          8%%>>%dispfile%
  if %percent%.==9. echo         ۱                                                9%%>>%dispfile%
 if %percent%.==10. echo                                                        10%%>>%dispfile%
 if %percent%.==11. echo         ۱                                              11%%>>%dispfile%
 if %percent%.==12. echo                                                       12%%>>%dispfile%
 if %percent%.==13. echo         ۱                                             13%%>>%dispfile%
 if %percent%.==14. echo                                                      14%%>>%dispfile%
 if %percent%.==15. echo         ۱                                            15%%>>%dispfile%
 if %percent%.==16. echo                                                     16%%>>%dispfile%
 if %percent%.==17. echo         ۱                                           17%%>>%dispfile%
 if %percent%.==18. echo                                                    18%%>>%dispfile%
 if %percent%.==19. echo         ۱                                          19%%>>%dispfile%
 if %percent%.==20. echo                                                   20%%>>%dispfile%
 if %percent%.==21. echo         ۱                                         21%%>>%dispfile%
 if %percent%.==22. echo                                                  22%%>>%dispfile%
 if %percent%.==23. echo         ۱                                        23%%>>%dispfile%
 if %percent%.==24. echo                                                 24%%>>%dispfile%
 if %percent%.==25. echo         ۱                                       25%%>>%dispfile%
 if %percent%.==26. echo                                                26%%>>%dispfile%
 if %percent%.==27. echo         ۱                                      27%%>>%dispfile%
 if %percent%.==28. echo                                               28%%>>%dispfile%
 if %percent%.==29. echo         ۱                                     29%%>>%dispfile%
 if %percent%.==30. echo                                              30%%>>%dispfile%
 if %percent%.==31. echo         ۱                                    31%%>>%dispfile%
 if %percent%.==32. echo                                             32%%>>%dispfile%
 if %percent%.==33. echo         ۱                                   33%%>>%dispfile%
 if %percent%.==34. echo                                            34%%>>%dispfile%
 if %percent%.==35. echo         ۱                                  35%%>>%dispfile%
 if %percent%.==36. echo                                           36%%>>%dispfile%
 if %percent%.==37. echo         ۱                                 37%%>>%dispfile%
 if %percent%.==38. echo                                          38%%>>%dispfile%
 if %percent%.==39. echo         ۱                                39%%>>%dispfile%
 if %percent%.==40. echo                                         40%%>>%dispfile%
 if %percent%.==41. echo         ۱                               41%%>>%dispfile%
 if %percent%.==42. echo                                        42%%>>%dispfile%
 if %percent%.==43. echo         ۱                              43%%>>%dispfile%
 if %percent%.==44. echo                                       44%%>>%dispfile%
 if %percent%.==45. echo         ۱                             45%%>>%dispfile%
 if %percent%.==46. echo                                      46%%>>%dispfile%
 if %percent%.==47. echo         ۱                            47%%>>%dispfile%
 if %percent%.==48. echo                                     48%%>>%dispfile%
 if %percent%.==49. echo         ۱                           49%%>>%dispfile%
 if %percent%.==50. echo                                    50%%>>%dispfile%
 if %percent%.==51. echo         ۱                          51%%>>%dispfile%
 if %percent%.==52. echo                                   52%%>>%dispfile%
 if %percent%.==53. echo         ۱                         53%%>>%dispfile%
 if %percent%.==54. echo                                  54%%>>%dispfile%
 if %percent%.==55. echo         ۱                        55%%>>%dispfile%
 if %percent%.==56. echo                                 56%%>>%dispfile%
 if %percent%.==57. echo         ۱                       57%%>>%dispfile%
 if %percent%.==58. echo                                58%%>>%dispfile%
 if %percent%.==59. echo         ۱                      59%%>>%dispfile%
 if %percent%.==60. echo                               60%%>>%dispfile%
 if %percent%.==61. echo         ۱                     61%%>>%dispfile%
 if %percent%.==62. echo                              62%%>>%dispfile%
 if %percent%.==63. echo         ۱                    63%%>>%dispfile%
 if %percent%.==64. echo                             64%%>>%dispfile%
 if %percent%.==65. echo         ۱                   65%%>>%dispfile%
 if %percent%.==66. echo                            66%%>>%dispfile%
 if %percent%.==67. echo         ۱                  67%%>>%dispfile%
 if %percent%.==68. echo                           68%%>>%dispfile%
 if %percent%.==69. echo         ۱                 69%%>>%dispfile%
 if %percent%.==70. echo                          70%%>>%dispfile%
 if %percent%.==71. echo         ۱                71%%>>%dispfile%
 if %percent%.==72. echo                         72%%>>%dispfile%
 if %percent%.==73. echo         ۱               73%%>>%dispfile%
 if %percent%.==74. echo                        74%%>>%dispfile%
 if %percent%.==75. echo         ۱              75%%>>%dispfile%
 if %percent%.==76. echo                       76%%>>%dispfile%
 if %percent%.==77. echo         ۱             77%%>>%dispfile%
 if %percent%.==78. echo                      78%%>>%dispfile%
 if %percent%.==79. echo         ۱            79%%>>%dispfile%
 if %percent%.==80. echo                     80%%>>%dispfile%
 if %percent%.==81. echo         ۱           81%%>>%dispfile%
 if %percent%.==82. echo                    82%%>>%dispfile%
 if %percent%.==83. echo         ۱          83%%>>%dispfile%
 if %percent%.==84. echo                   84%%>>%dispfile%
 if %percent%.==85. echo         ۱         85%%>>%dispfile%
 if %percent%.==86. echo                  86%%>>%dispfile%
 if %percent%.==87. echo         ۱        87%%>>%dispfile%
 if %percent%.==88. echo                 88%%>>%dispfile%
 if %percent%.==89. echo         ۱       89%%>>%dispfile%
 if %percent%.==90. echo                90%%>>%dispfile%
 if %percent%.==91. echo         ۱      91%%>>%dispfile%
 if %percent%.==92. echo               92%%>>%dispfile%
 if %percent%.==93. echo         ۱     93%%>>%dispfile%
 if %percent%.==94. echo              94%%>>%dispfile%
 if %percent%.==95. echo         ۱    95%%>>%dispfile%
 if %percent%.==96. echo             96%%>>%dispfile%
 if %percent%.==97. echo         ۱   97%%>>%dispfile%
 if %percent%.==98. echo            98%%>>%dispfile%
 if %percent%.==99. echo         ۱  99%%>>%dispfile%
if %percent%.==100. echo         ۳ 100%%>>%dispfile%


echo         >>%dispfile%
goto pcdone

:nopc
echo.>>%dispfile%
echo         Ŀ>>%dispfile%
echo                                                              0%%>>%dispfile%
echo         >>%dispfile%

:pcdone

type %out% | %find% "Status: " /i | %find% "paused" /i >nul
if errorlevel 1 goto nopause
if %autoupdate%.==1. set autoupdate=2
if %autoupdate%.==0. set autoupdate=1
goto endfetch
:nopause
set autoupdate=0
:endfetch
if exist %out% del %out%
if exist %outflag% del %outflag%
if exist %in% del %in%
if exist %inflag% del %inflag%
goto top

:notrunning
echo.>%dispfile%
echo  AMPlay is not running on the remote system.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
set autoupdate=2
goto endfetch

:rcgasleep
echo.>%dispfile%
echo  AMPlayRCG is asleep on the remote system.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
set autoupdate=2
goto endfetch

:noresp
echo.>%dispfile%
echo  AMPlayRCG is asleep or not running.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
echo.>>%dispfile%
set autoupdate=2
goto endfetch


:action
if exist %inflag% if not exist %in% goto recover
if exist %inflag% goto fetch
echo %act%>>%in%
echo.>%inflag%
echo.
echo Sent %act%
set autoupdate=0
if exist %outflag% goto actend
if %verbose%.==on. echo Action wait 1
%sleep% 1
if exist %outflag% goto actend
if %verbose%.==on. echo Action wait 2
%sleep% 1
if exist %outflag% goto actend
if %verbose%.==on. echo Action wait 3
%sleep% 1
goto fetch

:recover
if %verbose%.==on. echo Inconsistency detected. Wait 2
REM inconsistency detected - wait and see if amplayrc resolves it for us.
sleep 2
REM if not, clear it ourselves.
if %verbose%.==on. if exist %inflag% echo Clearing inconsistency ourselves.
if exist %inflag% if not exist %in% del %inflag%
goto fetch


:actend
REM delete output - we're not interested in it.
if exist %out% del %out%
if exist %outflag% del %outflag%
if %act%.==rcg#sleep. goto rcgasleep
goto request

:exit
echo.>>%webfile%
echo AMPlayRCC is not running at present. This file is not being updated.>>%webfile%

:stop

